# -*- coding: utf-8 -*-

#CALCUL NUMERIQUE DES ENERGIES POTENTIELLE, CINETIQUE ET MECANIQUE D'UN OBJET EN CHUTE LIBRE

import matplotlib.pyplot as plt


#declaration des variables et de leur valeur initiale

g= 9.8       #m.s-2
v= 0       #m/s
m= 0.030       #kg

tau=0.0001

x= 0        #m
z0= 1.66       #m
z=z0       #m 
t= 0       #s

#Expression littérale des énergies

Epp= m*g*z
Ec= 0.5*m*v*v
Em= Ec+Epp

# Affichage à l'écran des valeurs initales

print ("hauteur initiale=",z,"m")
print ("Energie potentielle de pesanteur initiale= ",Epp,"J")
print ("Energie cinétique initiale= ",Ec,"J")
print ("Energie mécanique initiale=",Em,"J")    


#t et z  sont des variables de type float, qu'il faut stocker dans
#des listes si on veut effectuer des tracers
zlist=[z]
tlist=[t]

EPPlist=[Epp]
EClist=[Ec]
EMlist=[Em]

#Calcul pas à pas des valeurs prises par t, z, vz, Ec, Epp et Em

while z>=0.05:
    z = z+v*tau
    t = t+tau
    v = v-g*tau

    Epp=m*g*z
    Ec=0.5*m*v*v
    Em=Ec+Epp


#... et stockage des valeurs calculees dans les listes creees

    zlist=zlist+[z]
    tlist=tlist+[t]
    EPPlist=EPPlist+[Epp]
    EClist=EClist+[Ec]
    EMlist=EMlist+[Em]
    
    # Affichage à l'écran des valeurs finales
    
print ("hauteur finale =",z,"m")
print ("Energie potentielle de pesanteur finale= ",Epp,"J")
print ("Energie cinétique finale = ",Ec,"J")
print ("Energie mécanique finale =",Em,"J")    

#Affichage des 3 courbes

plt.title('Variation énergétique d une balle en chute libre - tau='+str(tau)+' s')
plt.xlabel('temps (s)')
plt.ylabel('Energie (J)')
plt.plot(tlist, EPPlist, 'b.',label="énergie potentielle")
plt.plot(tlist, EClist, 'r.', label="énergie cinétique")
plt.plot(tlist, EMlist, 'y.', label="énergie mécanique")
plt.legend()
plt.show()
